// CRF Electronic Systems.                                       ////
// Conjunto de funciones creadas para facilitar la programacin. ////

// FUNCION FSETS    = Setea lo mas usual
// FUNCION FCAJA1   = Crea un box (L,C,l,c," titulo ","W+/N*")
// FUNCION FCAJA2   = Crea un box centrado (L,C," titulo ")
//                    L = cant. lineas , C = cant. columnas
// FUNCION FCAJA3   = Crea un box con 1 mensaje y 2 opciones ACEPTAR CANCELAR
//                    FCAJA3 ("Titulo" , "Mensaje 1" , "Mensaje 2" )
//                    ACEPTAR = .T.  /  CANCELAR = .F.
// FUNCION FCAJA4   = Crea un box centrado con 1 o 2 lineas de texto
//                    Fcaja4 ('Titulo en rojo','Mensaje 1','Mensaje 2')

// FUNCION FSALVA   = Llama al salvapantallas (SAVER) con F4
// FUNCION FFLECHA  = Dibuja una flecha " > "
// FUNCION FCENT    = Centra un texto = FCENT (L," TEXTO ","COLOR")

// FUNCION FLIMPIA  = Limpia de 2,1 a 23,78 crea fondo "BG"
// FUNCION FLIM24   = Limpia linea 24 ("Y escribe el mensaje ?")color W+/N*
// FUNCION FLIM24U  = Limpia 24 y esc."Utilice las flechas para desplazarse
//                    y < ENTER > para seleccionar. " 
// FUNCION FPANT1   = Crea pantalla principal ( "texto L0" , "texto L1" )

// FUNCION FSALIR   = Cierra bases de datos,setea colores DOS ,sale del prg.

// FUNCION FFECHA1  = Muestra fecha >> Martes 21/10/1999  (20 car.)
// FUNCION FFECHA2  = Muestra fecha >> Martes 21 de Octubre de 1999 (33 car.)

// FUNCION FCALC1   = Tabla de equivalencias medidas llaves en pulgadas a mm.
// FUNCION FCALC2   = Calcula cilindrada de un motor
// FUNCION FCALC3   = Calcula medidas de cubiertas
// FUNCION FCALC4   = Convierte medidas de gicleurs pulgadas a milimetros

// FUNCION FPUB1    = Primera pantalla publicidad
// FUNCION FBARRA1  = Barra de izquierda a derecha
// FUNCION FMENS1   = Mensaje corregir hora y fecha
// FUNCION FPAUSA   = Interrumpe la ejecucion hasta pulsar una tecla
// FUNCION FPRINT1  = Verifica impresora Si es OK = .T. Cancelar = .F.
// FUNCION FUPPER   = Convierte a mayuscula la primera letra de cada palabra
//                    Uso: Fupper ('Variable a modificar')

// FUNCION FPORMEN  = Calcula porciento menos FPORMEN (VALOR,PORCENTAJE)
// FUNCION FPORMAS  = Calcula porciento mas FPORMAS (VALOR,PORCENTAJE)

// FUNCION FNODISP  = Mensaje "Funcion no disp.en la vers. de evaluacion"
//------------------------------------------------------------------------//
FUNCTION FSETS

  #INCLUDE "INKEY.CH"
  SETCANCEL ()
  SET CENTURY ON
  SET DATE FRENCH
  SET DATE FORMAT TO "dd/mm/yyyy"
  SET EPOCH TO 1970
  SET SCOREBOARD OFF
  SETBLINK (.F.)
  SET BELL OFF
  SET WRAP ON
  SET MESSAGE TO 23 
  SET KEY K_F4 TO FSALVA()

RETURN
//------------------------------------------------------------------------//
FUNCTION FCAJA1

PARAMETERS INIL,INIC,FINL,FINC,TEXTO,COL
  IF PCOUNT () = 5
     PRIVATE COL := "W+/N*"
  ENDIF
PRIVATE XFIN
SET COLOR TO N/W*,W+/N,N,,BG+/N

 @ INIL,FINC-2,FINL,FINC BOX "" COLOR"N/BG" 
 @ INIL,INIC,INIL,FINC-1 BOX "" COLOR"N+"
 @ INIL,INIC SAY " " + CHR(4) COLOR"R+/N*"
 @ INIL,INIC+3 SAY TEXTO COLOR COL
 @ INIL+1,INIC,FINL,FINC-1 BOX "     " COLOR"N+/W*" 
 @ FINL,INIC SAY "" COLOR"N+/BG"
 XFIN = FINC - (INIC+1)
 @ FINL,INIC+1 SAY REPLICATE ("",XFIN) COLOR"N+/N"
               
RETURN NIL
//------------------------------------------------------------------------//
FUNCTION FCAJA2

PARAMETERS LINEAS,COLUMN,TEXTO
PRIVATE INIL,INIC,FINL,FINC,XFIN
SET COLOR TO N/W*,W+/N,N,,BG+/N

  IF LINEAS > 20
     PRIVATE LINEAS
     LINEAS = 20
  ENDIF

  IF COLUMN > 76
     PRIVATE COLUMN
     COLUMN = 76
  ENDIF

INIL = INT((24-LINEAS)/2)+1
INIC = INT((80-COLUMN)/2)
FINL = INIL + LINEAS
FINC = INIC + COLUMN

 @ INIL,FINC-2,FINL,FINC BOX "" COLOR"N/BG"
 @ INIL,INIC,INIL,FINC-1 BOX "" COLOR"N+"
 @ INIL,INIC SAY " " + CHR(4) COLOR"R+/N*"
 @ INIL,INIC+3 SAY TEXTO COLOR "W+/N*"
 @ INIL+1,INIC,FINL,FINC-1 BOX "     " COLOR"N+/W*"
 @ FINL,INIC SAY "" COLOR"N+/BG"
 XFIN = FINC - (INIC+1)
 @ FINL,INIC+1 SAY REPLICATE ("",XFIN) COLOR"N+/N"
               
RETURN NIL
//-------------------------------------------------------------------------//
FUNCTION FCAJA3 (XTEX,XTEX2,XTEX3)

DO CASE
   CASE XTEX == 'A'
        PRIVATE XTEX1 := 'Aviso de error:', XCOL := 'R+/N*'
   OTHERWISE
        PRIVATE XTEX1 := XTEX , XCOL := 'R+/N*'
ENDCASE

// FLIMPIA ()
  IF PCOUNT () = 2
     FCAJA1 (10,20,16,60,XTEX1,XCOL)
     FCENT (12,XTEX2)
  ELSEIF PCOUNT () = 3
     FCAJA1 (9,20,16,60,XTEX1,XCOL)
     FCENT (11,XTEX2)
     FCENT (12,XTEX3)
  ENDIF
FLIM24 ('Elija la opcin < ACEPTAR > o < CANCELAR >')
@ 14,24,15,37 BOX "   " COLOR"N+/W*"
@ 14,43,15,56 BOX "   " COLOR"N+/W*"
@ 14,23 PROMPT "[  Aceptar   ]"
@ 14,42 PROMPT "[  Cancelar  ]"
MENU TO OPCION
RETURN IIF (OPCION = 1,.T.,.F.)
//-------------------------------------------------------------------------//
FUNCTION FCAJA4 (XTEX,XTEX2,XTEX3)

PRIVATE XTEX1 := XTEX , XCOL := 'R+/N*'

  IF PCOUNT () = 2
     FCAJA1 (11,20,15,60,XTEX1,XCOL)
     FCENT (13,XTEX2)
  ELSEIF PCOUNT () = 3
     FCAJA1 (10,20,15,60,XTEX1,XCOL)
     FCENT (12,XTEX2)
     FCENT (13,XTEX3)
  ENDIF
Return nil
//-------------------------------------------------------------------------//
FUNCTION FSALVA      ///// Llamada al salvapantallas //////////

TONE (1000,1)
RUN SAVER

RETURN SETBLINK (.F.)
//-------------------------------------------------------------------------//
FUNCTION FFLECHA

RETURN ">" 
//------------------------------------------------------------------------//
FUNCTION FCENT

PARAMETERS LINEA,TEXTO,COL
  IF PCOUNT () = 2
     PRIVATE COL := "N/W*"
  ENDIF
PRIVATE LINEA,UBICA

UBICA = INT((80-LEN(TEXTO))/2)
@ LINEA,UBICA SAY TEXTO COLOR COL

RETURN 
//------------------------------------------------------------------------//
FUNCTION FLIMPIA

   @ 2,1 CLEAR TO 23,78
   @ 2,1,23,78 BOX "" COLOR"BG"
  @ 23,0 SAY "" COLOR"N+/BG"
 @ 23,79 SAY "" COLOR"N+/BG"

RETURN
//------------------------------------------------------------------------//
FUNCTION FLIM24

PARAMETERS TEX1
  IF PCOUNT () = 0
     PRIVATE TEX1
     TEX1 = ""
  ENDIF        

  @ 24,0 CLEAR TO 24,79
  @ 24,0,24,79 BOX "" COLOR"N+"
  @ 24,1 SAY TEX1 COLOR"W+/N*"

RETURN
//------------------------------------------------------------------------//
FUNCTION FLIM24U

  @ 24,0 CLEAR TO 24,79
  @ 24,0,24,79 BOX "" COLOR"N+"
@ 24,1 SAY "Utilice las flechas para desplazarse y < ENTER > para seleccionar.";
COLOR "W+/N*"

RETURN
//------------------------------------------------------------------------//
FUNCTION FPANT1

PARAMETERS TEX1,TEX2

  IF PCOUNT () = 1
     PRIVATE TEX2
     TEX2 = ""
  ENDIF        

SET COLOR TO N/W*,W+/N,N,,W/N
                    
    @ 0,0,1,79 BOX " " COLOR"N+"
   @ 0,71,0,78 BOX " " COLOR"W+/N*" 
   @ 2,0,23,79 BOX "   " COLOR"N+/BG"
  @ 24,0,24,79 BOX " " COLOR"N+"

 @ 0,1 SAY CHR(240) COLOR"R+/N*"
 @ 0,3 SAY TEX1 COLOR"W+/N*"
 @ 1,1 SAY CHR(240) COLOR"R+/N*" 
 @ 1,3 SAY TEX2 COLOR"W+/N*" 
@ 1,45 SAY FFECHA2 () COLOR"W+/N*"
FLIM24 ("Elija una opcin y presione < ENTER >")

RETURN
//-----------------------------------------------------------------------//
FUNCTION FSALIR

    SET COLOR TO W/N
    CLOSE ALL
    CLS
    QUIT

RETURN NIL
//-----------------------------------------------------------------------//
FUNCTION FFECHA1

//// Muestra la fecha actual en formato: DIA,FECHA,MES y AO  //
////////   ATENCION !!!  Largo maximo que ocupa: 20 caracteres.   ///////

PRIVATE AWDIA := DOW (DATE ()) 
PRIVATE AXDIA

DO CASE
CASE AWDIA = 1
AXDIA = "  Domingo"
CASE AWDIA = 2
AXDIA = "    Lunes"
CASE AWDIA = 3
AXDIA = "   Martes"
CASE AWDIA = 4
AXDIA = "Miercoles" 
CASE AWDIA = 5
AXDIA = "   Jueves"
CASE AWDIA = 6
AXDIA = "  Viernes"
CASE AWDIA = 7
AXDIA = "   Sabado"
ENDCASE

RETURN  (AXDIA) + " " + LTRIM(STR(DAY(DATE()))) + "/" +; 
        LTRIM(STR(MONTH(DATE()))) + "/" + LTRIM(STR(YEAR(DATE())))
//------------------------------------------------------------------------//
FUNCTION FFECHA2

//// Muestra la fecha actual en formato: DIA,FECHA,(nombre del) MES y AO  //
////////   ATENCION !!!  Largo maximo que ocupa: 33 caracteres.   ///////

PRIVATE AWMES := MONTH ( DATE ()) 
PRIVATE AWDIA := DOW ( DATE ()) 
PRIVATE AZMES 
PRIVATE AXMES
PRIVATE AXDIA

DO CASE
CASE AWMES = 1
AXMES = "Enero"
AZMES = "    "
CASE AWMES = 2
AXMES = "Febrero"
AZMES = "  "
CASE AWMES = 3 
AXMES = "Marzo"
AZMES = "    "
CASE AWMES = 4
AXMES = "Abril"
AZMES = "    "
CASE AWMES = 5
AXMES = "Mayo"
AZMES = "     "
CASE AWMES = 6
AXMES = "Junio"
AZMES = "    "
CASE AWMES = 7
AXMES = "Julio"
AZMES = "    "
CASE AWMES = 8
AXMES = "Agosto"
AZMES = "   "
CASE AWMES = 9
AXMES = "Setiembre"
AZMES = ""
CASE AWMES = 10
AXMES = "Octubre"
AZMES = "  "
CASE AWMES = 11
AXMES = "Noviembre"
AZMES = ""
CASE AWMES = 12
AXMES = "Diciembre"
AZMES = ""
ENDCASE

DO CASE
CASE AWDIA = 1
AXDIA = "  Domingo"
CASE AWDIA = 2
AXDIA = "    Lunes"
CASE AWDIA = 3
AXDIA = "   Martes"
CASE AWDIA = 4
AXDIA = "Miercoles"
CASE AWDIA = 5
AXDIA = "   Jueves"
CASE AWDIA = 6
AXDIA = "  Viernes"
CASE AWDIA = 7
AXDIA = "   Sabado"
ENDCASE

IF YEAR (DATE ()) >= 2000

RETURN  (AZMES) + (AXDIA) + " " + STRZERO(DAY(DATE()),2) + " de " +; 
        (AXMES) + " de" + STR(YEAR(DATE()))

ELSEIF YEAR (DATE ()) < 2000

RETURN  (AZMES) + " " + (AXDIA) + " " + STRZERO(DAY(DATE()),2) + " de " +; 
        (AXMES) + " de" + STR(YEAR(DATE()))
ENDIF
//-----------------------------------------------------------------------//
//-----------------------------------------------------------------------//
//-----------------------------------------------------------------------//
FUNCTION FPUB1

PARAMETERS TEX1,TEX2,TEX3
CLEAR
@ 2,15,15,63 BOX "" COLOR"B/B"
@ 3,16,15,62 BOX "ͻȺ " COLOR"W/B"
@ 2,18,4,60 BOX "ͻ̼ȹ " COLOR"W/B"
FCENT(3,TEX1,"R+/B") 
@ 6,16 SAY "" COLOR"W/B"
@ 6,17 SAY "" COLOR"W/B"                                 
@ 5,18,7,60 BOX "Ŀ " COLOR"W/B"
@ 6,61 SAY "" COLOR"W/B"
@ 6,62 SAY "" COLOR"W/B"
@ 6,34 SAY "Versin: " + TEX2 COLOR"W+/B"
  @ 11,16 SAY "" COLOR"W/B"
  @ 11,17 SAY "" COLOR"W/B"
  @ 8,18,14,60 BOX "ͻȺ " COLOR"W/B"
  @ 11,18 SAY "" COLOR"W/B"
  @ 11,60 SAY "" COLOR"W/B"
  @ 11,61 SAY "" COLOR"W/B"
  @ 11,62 SAY "" COLOR"W/B"
 @ 9,20 SAY "Creado por:" COLOR"W/B"
@ 10,22 SAY "     C R F  Electronic Systems     " COLOR"G+/B"
@ 11,22 SAY "          (0220) 499-8257          " COLOR"W+/B"
@ 12,22 SAY "     cybersound_crf@Hotmail.com    " COLOR"W+/B"
FCENT (13,TEX3,"W+/B")
@ 17,15,21,63 BOX ""                 COLOR"B/B"
@ 17,16,21,62 BOX "Ŀ "                 COLOR"W/B"
@ 18,18 SAY "Sistema operativo:           MS" COLOR"W+/B"
@ 18,51 SAY OS()                              COLOR"W+/B"
@ 19,18 SAY "Memoria convencional disp.:"     COLOR"W+/B"
Private Xmemory
Xmemory = MEMORY()
@ 19,44 SAY Xmemory                           COLOR"W+/B"
@ 19,55 SAY "Kbytes"                          COLOR"W+/B"
@ 20,18 SAY "Espacio libre en disco:"         COLOR"W+/B"
LUGAR = STR(DISKSPACE())
@ 20,42 SAY SUBSTR(LUGAR,1,4)+","+SUBSTR(LUGAR,5,3)+"."+SUBSTR(LUGAR,8,3) COLOR"W+/B"
@ 20,55 SAY "Mbytes"                          COLOR"W+/B"
If Xmemory <= 200
   Tone (1000,3)
   Fcent (22,'Memoria RAM insuficiente para ejecutar el software con seguridad.!!!','R+/N')
   Fcent (23,'Llame al numero arriba indicado para recibir soporte tecnico.','R+/N')
Endif
If Diskspace () <= 10000000
   Tone (1000,3)
   Fcent (22,'Espacio en disco insuficiente para ejecutar el software con seguridad.!!!','R+/N')
   Fcent (23,'Llame al numero arriba indicado para recibir soporte tecnico.','R+/N')
Endif
FPAUSA ()
RETURN NIL
//-----------------------------------------------------------------------//
FUNCTION FBARRA1

Fcaja2 (5,48,'Aguarde...') 
@ 12,19 SAY "Actualizando informacion... "
@ 13,19 SAY ""COLOR"B"
LIN = 19                        
  FOR I = 1 TO 20
      @ 13,LIN SAY ""COLOR"B+"
      INKEY (0.01)
      LIN = LIN + 2            
  NEXT
RETURN NIL
//-----------------------------------------------------------------------//
FUNCTION FMENS1

FCAJA1 (4,16,19,63,"Atencin:")
 @ 6,19 SAY "Este programa utiliza la HORA y FECHA" 
 @ 7,19 SAY "del reloj interno de su computadora." 
 @ 9,19 SAY "Hora:" 
 @ 9,24 SAY TIME () 
 @ 9,34 SAY "Fecha:" 
 @ 9,40 SAY FFECHA1 () 
@ 11,19 SAY "Si estos datos no son los correctos:" 
@ 13,19 SAY "Abandone el programa y desde el  C:\>" 
@ 14,19 SAY "Escriba TIME para corregir la hora." 
@ 15,19 SAY "Escriba DATE para corregir la fecha." 
@ 17,25,18,37 BOX "   " COLOR"N+/W*"
@ 17,43,18,55 BOX "   " COLOR"N+/W*"
@ 17,24 PROMPT "[ Continuar ]"
@ 17,42 PROMPT "[   Salir   ]"
MENU TO OPCION
  DO CASE
     CASE OPCION = 1
          FLIMPIA ()
     CASE OPCION = 2
          FSALIR ()
  ENDCASE
RETURN NIL
//------------------------------------------------------------------------//
FUNCTION FCALC1
// Tabla de equivalencias medidas de llaves en pulgadas a mm.

FLIMPIA ()
FCAJA1 (3,6,22,74,"Tabla de equivalencias:")

 @ 4,7 SAY "Fraccin de pulgada  Milimetros | Fraccin de pulgada  Milimetros"
 @ 5,7 SAY "                                |                                "
 @ 6,7 SAY " 1/32               =   0,793   |  17/32              =  13,493  "
 @ 7,7 SAY "     1/16           =   1,587   |        9/16         =  14,287  "
 @ 8,7 SAY " 3/32               =   2,381   |  19/32              =  15,081  "
 @ 9,7 SAY "         1/8        =   3,175   |            5/8      =  15,875  "
@ 10,7 SAY " 5/32               =   3,968   |  21/32              =  16,668  "
@ 11,7 SAY "     3/16           =   4,762   |       11/16         =  17,462  "
@ 12,7 SAY " 7/32               =   5,556   |  23/32              =  18,256  "
@ 13,7 SAY "            1/4     =   6,350   |               3/4   =  19,050  "
@ 14,7 SAY " 9/32               =   7,143   |  25/32              =  19,843  "
@ 15,7 SAY "     5/16           =   7,937   |       13/16         =  20,637  "
@ 16,7 SAY "11/32               =   8,731   |  27/32              =  21,431  "
@ 17,7 SAY "         3/8        =   9,525   |            7/8      =  22,225  "
@ 18,7 SAY "13/32               =  10,318   |  29/32              =  23,018  "
@ 19,7 SAY "     7/16           =  11,112   |       15/16         =  23,812  "
@ 20,7 SAY "15/32               =  11,906   |  31/32              =  24,606  "
@ 21,7 SAY "               1/2  =  12,700   |                  1  =  25,400  "


FLIM24 (" Presione cualquier tecla para volver al men principal.")
INKEY (0)
FLIMPIA ()
RETURN NIL
//-----------------------------------------------------------------------//
FUNCTION FCALC2      // Calcula cilindrada de un motor

FLIMPIA ()
FCAJA1 (5,10,13,69,"Calcular la cilindrada de un motor:")
FLIM24 ("Ingrese los datos requeridos.")
PRIVATE XDIA,XCAR,XNUM,XCIL
XDIA = 0
XCAR = 0
XNUM = 0

 @ 7,12 SAY "Ingrese el diametro de los cilindros en mm.  ";
   GET XDIA PICTURE "999.99"
 @ 8,12 SAY "Ingrese la carrera del pistn en mm.          ";
   GET XCAR PICTURE "999.99"
 @ 9,12 SAY "Ingrese el nmero de cilindros del motor:     ";
   GET XNUM PICTURE "999999" VALID(XNUM < 19) 
READ

XCIL = (XDIA*XDIA) * XCAR * 3.14159 * XNUM / 4

 @ 11,12 SAY "La cilindrada del motor es: "
 @ 11,40 SAY XCIL / 1000  PICTURE "999999.999" COLOR"G+/N"
 @ 11,51 SAY "centimetros cub."

FLIM24 ("Presione cualquier tecla para volver al men principal.")
INKEY (0)
FLIMPIA ()
RETURN NIL
//-----------------------------------------------------------------------//
FUNCTION FCALC3     // Calcula medidas de cubiertas

FLIMPIA ()
FCAJA1 (4,9,22,70,"Calcular medida y pisada de neumaticos:")
FLIM24 ("Ingrese los datos requeridos.")
PRIVATE XMED1,XMED2,XMED3,XMED4,XMED5,XMED6,XMED7,XRELA
XMED1 = 0
XMED2 = 0
XMED3 = 0
XRELA = 0

 @ 6,11 SAY "Ingrese las medidas del neumatico: "
 @ 6,51 GET XMED1 PICTURE "999"
 @ 6,56 GET XMED2 PICTURE "99"
 @ 6,60 GET XMED3 PICTURE "99" VALID (XMED3 < 21) 
READ

XMED4 = 2 * XMED1 * XMED2 / 2540 + XMED3
XMED5 = XMED4 * 2.54

  @ 8,11 SAY "El diametro del neumatico es de:  "
  @ 8,49 SAY XMED4 PICTURE "99.999"
  @ 8,56 SAY "Pulgadas."
  @ 9,48 SAY XMED5 PICTURE "999.999"
  @ 9,56 SAY "Centimetros."
 @ 10,11 SAY "La pisada del neumatico es de:"
XMED6 = XMED5 * 3.14159
 @ 10,48 SAY XMED6  PICTURE "999.999"
 @ 10,56 SAY "Centimetros."
 @ 11,11 SAY "Para recorrer 1 Kmt. rodar:"
 @ 11,47 SAY 100000 / XMED6  PICTURE "9999.99"
 @ 11,56 SAY "Vueltas."
 @ 13,11 SAY "Indique la relacin de diferencial:"
 @ 13,56 SAY "a 1"
 @ 13,50 GET XRELA PICTURE "9.999"
READ
XMED7 = 1000 / XRELA * 60 * (XMED6 / 100000)
 @ 15,11 SAY "Velocidad a 1000rpm en directa:"
 @ 15,48 SAY XMED7 PICTURE "999.99"
 @ 15,56 SAY "Kmt. x Hora"
 @ 16,11 SAY "Velocidad a 2000rpm en directa:"
 @ 16,48 SAY XMED7 * 2  PICTURE "999.99"
 @ 16,56 SAY "Kmt. x Hora"
 @ 17,11 SAY "Velocidad a 2500rpm en directa:"
 @ 17,48 SAY XMED7 * 2.5  PICTURE "999.99"
 @ 17,56 SAY "Kmt. x Hora"
 @ 18,11 SAY "Velocidad a 3000rpm en directa:"
 @ 18,48 SAY XMED7 * 3  PICTURE "999.99"
 @ 18,56 SAY "Kmt. x Hora"
 @ 19,11 SAY "Velocidad a 4000rpm en directa:"
 @ 19,48 SAY XMED7 * 4  PICTURE "999.99"
 @ 19,56 SAY "Kmt. x Hora"
 @ 20,11 SAY "Velocidad a 5000rpm en directa:"
 @ 20,48 SAY XMED7 * 5  PICTURE "999.99"
 @ 20,56 SAY "Kmt. x Hora"
 @ 21,11 SAY "Velocidad a 6000rpm en directa:"
 @ 21,48 SAY XMED7 * 6  PICTURE "999.99"
 @ 21,56 SAY "Kmt. x Hora"

FPAUSA ()
FLIMPIA ()
RETURN NIL
//-----------------------------------------------------------------------//
FUNCTION FCALC4   // Convierte medidas de gicleurs pulgadas a milimetros. 

FLIMPIA ()
FCAJA1 (6,11,12,68,"Convertir medidas de gicleurs americanos:")
FLIM24 ("Ingrese el dato requerido.")
PRIVATE XAME,XEUR
XAME = 0
XEUR = 0

@ 8,13 SAY "Ingrese el nmero del gicleur americano.       ";
GET XAME PICTURE "999"
READ

XEUR = XAME * 2.54

@ 10,13 SAY "La equivalencia europea es: "
@ 10,42 SAY XEUR PICTURE "999.9"
@ 10,48 SAY "Centsimas de mm."

FLIM24 ("Presione cualquier tecla para volver al men principal.")
INKEY (0)
FLIMPIA ()

RETURN NIL
//-----------------------------------------------------------------------//
FUNCTION FPAUSA

SET CURSOR OFF
FLIM24 ("Presione cualquier tecla para continuar.")
INKEY (0)
SET CURSOR ON

RETURN NIL
//-----------------------------------------------------------------------//
FUNCTION FPRINT1

SET CURSOR OFF
DO WHILE .T.
PRIVATE XEXIT := 'A'
  IF !ISPRINTER ()
     FCAJA2 (6,40,'Estado de la impresora:')
     INKEY (0.5)
     TONE (1000,1)
     TONE (700,1)
     TONE (1000,1)
     FLIM24 ('Si elije < CANCELAR >  No se realizar la impresin...')
     @ 12,22 SAY " La impresora no est disponible. !" COLOR"R+/W*"
     @ 14,24,15,37 BOX "   " COLOR"N+/W*"
     @ 14,43,15,56 BOX "   " COLOR"N+/W*"
     @ 14,23 PROMPT "[ Reintentar ]"
     @ 14,42 PROMPT "[  Cancelar  ]"
     MENU TO OPCION
       DO CASE
          CASE OPCION = 1
               LOOP
          CASE OPCION = 2
               XEXIT = 'SALE'
               EXIT
       ENDCASE
  ELSEIF ISPRINTER ()
     FCAJA2 (6,40,'Estado de la impresora:')
     TONE (1000,1)
     @ 13,37 SAY CHR(17) + ' OK '+ CHR(16) COLOR"B+/W*"
     INKEY (1)
     EXIT
  ENDIF
EXIT
ENDDO
SET CURSOR ON
RETURN IIF (XEXIT='SALE',.F.,.T.)
//-----------------------------------------------------------------------//
FUNCTION FPORMEN (VALOR,PORC)  // Calcula porciento menos //

PRIVATE XVAL := 0
XVAL = VALOR * PORC / 100
RETURN VALOR - XVAL
//-----------------------------------------------------------------------//
FUNCTION FPORMAS (VALOR,PORC)  // Calcula porciento mas // 

PRIVATE XVAL := 0
XVAL = VALOR * PORC / 100
RETURN VALOR + XVAL
//-----------------------------------------------------------------------//
FUNCTION FUPPER (Cad1)

Private Cad2 := " ,;.:-_'{}[]()*+<>?!`~=/\%$@#|"+Chr (34)
Private Pos,Switch,Cad3
Switch = .T.
Cad3 = Space (0)
   For Pos = 1 to Len (Cad1)
       Do case
          Case !Substr (Cad1,Pos,1)$Cad2 .and. Switch
               Switch = .F.
               Cad3 = Cad3 + Upper (Substr (Cad1,Pos,1))
          Case Substr (Cad1,Pos,1)$Cad2
               Switch = .T.
               Cad3 = Cad3 + Substr (Cad1,Pos,1)
          Otherwise
               Cad3 = Cad3 + Substr (Cad1,Pos,1)
       Endcase
   Next
Cad1 = Cad3
Return Cad1
// ***********************************************************************
Function Fnodisp
Flimpia ()
Tone (1000,1)
Fcaja2 (5,31,'Aviso')
Fcent (12,'Funcion no disponible en ','R+/W*')
Fcent (13,'la version de evaluacion.','R+/W*')
Fpausa ()
Return nil
//-----------------------------------------------------------------------//
//-----------------------------------------------------------------------//
